## mingw-w64-pdcurses-4.5.3-1.src.tar.zst

=== dosvga/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "MinSizeRel" CACHE STRING "Choose the type of build, options are: Debug, Release, or MinSizeRel." FORCE)
    message(STATUS "No build type specified, defaulting to MinSizeRel.")
endif()

PROJECT(dosvga VERSION "${PROJECT_VERSION}" LANGUAGES C)
MESSAGE(STATUS "${PROJECT_NAME} version: ${PROJECT_VERSION}")

include(project_common)

if(WATCOM)
    # this requires using the following toolchainfile file
    #     -DCMAKE_TOOLCHAIN_FILE={path}\watcom_open_dos_toolchain.cmake

    string(APPEND CMAKE_C_FLAGS " -wx")  # warning level: to maximum setting
    
    if(WATCOM_DOS16)
        string(APPEND CMAKE_C_FLAGS " -ml")  # memory model: options are large (-ml), memdium (-mm), small (-ms)
    else()
        string(APPEND CMAKE_C_FLAGS " -mf")  # memory model: options are flat (-mf), large (-ml), memdium (-mm), small (-ms)
    endif()

    string(APPEND CMAKE_C_FLAGS_RELEASE " -oneatx")
    string(APPEND CMAKE_C_FLAGS_MINSIZEREL " -oneatx")
    # optimization: 
    # n -> allow numerically unstable optimizations
    # e -> expand user functions inline
    # a -> relax aliasing constraints
    # t -> favor execution time over code size in optimizations
    # x -> equivalent to -obmiler -s

    string(APPEND CMAKE_C_FLAGS_DEBUG " -d2") # full symbolic debugging info
    string(APPEND CMAKE_EXE_LINKER_FLAGS_DEBUG " debug watcom all")

endif()

demo_app(../demos calendar)
demo_app(../demos firework)
demo_app(../demos init_col)
demo_app(../demos mbrot)
demo_app(../demos newtest)
demo_app(../demos ozdemo)
demo_app(../demos picsview)
demo_app(../demos ptest)
demo_app(../demos rain)
demo_app(../demos speed)
demo_app(../demos test_pan)
demo_app(../demos testcurs)
demo_app(../demos version)
demo_app(../demos widetest)
demo_app(../demos worm)
demo_app(../demos xmas)

=== fb/Makefile ===
# GNU MAKE Makefile for PDCurses library for Linux framebuffer
#
# Usage: [g]make [DEBUG=Y] [WIDE=Y] [UTF8=Y] [LIBNAME=(name)]
#                [DLLNAME=(name)] [DRM=Y] [CHTYPE_32=Y] [target]
#
# where target can be any of:
# [all|demos|libpdcurses.a|testcurs]...

O = o

ifndef PDCURSES_SRCDIR
	PDCURSES_SRCDIR = ..
endif

osdir		= $(PDCURSES_SRCDIR)/fb
common		= $(PDCURSES_SRCDIR)/common

include $(common)/libobjs.mif

RM		= rm -f

# If your system doesn't have these, remove the defines here
SFLAGS		= -DHAVE_VSNPRINTF -DHAVE_VSSCANF

CFLAGS  = -Wall -Wextra -pedantic -Werror
ifeq ($(DEBUG),Y)
	CFLAGS  += -g -DPDCDEBUG
else
	CFLAGS  += -O2
endif

ifeq ($(HAVE_MOUSE),Y)
	CFLAGS  += -DHAVE_MOUSE
	ADDED_PDCOBJS=pdcmouse.$(O)
endif

CFLAGS	+= -fPIC

ifeq ($(UTF8),Y)
	CFLAGS	+= -DPDC_WIDE -DPDC_FORCE_UTF8
else
	ifeq ($(WIDE),Y)
		CFLAGS	+= -DPDC_WIDE
	endif
endif

ifdef CHTYPE_32
	CFLAGS += -DCHTYPE_32
endif

LIBNAME=pdcurses
DLLNAME=pdcurses

LIBFLAGS = rv
LIBCURSES	= lib$(LIBNAME).a
CC	= $(PREFIX)gcc
LIBEXE = $(PREFIX)ar
STRIP	= $(PREFIX)strip

ifeq ($(shell uname -s),FreeBSD)
	CC = cc
endif

ifeq ($(DLL),Y)
		DLL_SUFFIX = .so
		LIBEXE = $(CC)
		LIBFLAGS = -shared -o
		LIBCURSES = lib$(DLLNAME)$(DLL_SUFFIX)
endif

BUILD		= $(CC) $(CFLAGS) -I$(PDCURSES_SRCDIR)

LINK		= $(CC)
LDFLAGS		= $(LIBCURSES)
RANLIB		= ranlib

ifeq ($(DRM),Y)
	CFLAGS += -DUSE_DRM -I /usr/include/drm -I /usr/include/libdrm
	LDFLAGS += -ldrm
endif

ifeq ($(shell uname -s),FreeBSD)
	CC = cc
	CFLAGS += -DUSE_DRM -I/usr/local/include -I/usr/local/include/libdrm
	LDFLAGS += -L /usr/local/lib -ldrm
endif

.PHONY: all libs clean demos tests

all:	libs

libs:	$(LIBCURSES)

clean:
	-$(RM) *.o trace $(LIBCURSES) $(DEMOS) $(TESTS)

demos:	libs $(DEMOS)
ifneq ($(DEBUG),Y)
	$(STRIP) $(DEMOS)
endif

tests:	libs $(TESTS)
ifneq ($(DEBUG),Y)
	$(STRIP) $(TESTS)
endif

$(LIBCURSES) : $(LIBOBJS) $(PDCOBJS)
	$(LIBEXE) $(LIBFLAGS) $@ $?
ifeq ($(LIBCURSES),lib$(LIBNAME).a)
	-$(RANLIB) $@
endif

$(LIBOBJS) $(PDCOBJS) : $(PDCURSES_HEADERS)
$(DEMOS) : $(PDCURSES_CURSES_H) $(LIBCURSES)
$(TESTS) : $(PDCURSES_CURSES_H) $(LIBCURSES)
tui.o tuidemo.o : $(PDCURSES_CURSES_H)
terminfo.o : $(TERM_HEADER)
panel.o ptest: $(PANEL_HEADER)

$(LIBOBJS) : %.o: $(srcdir)/%.c
	$(BUILD) $(SFLAGS) -c $<

$(PDCOBJS) : %.o: $(osdir)/%.c
	$(BUILD) $(SFLAGS) -c $<

$(DEMOS_EXCEPT_TUIDEMO): %: $(demodir)/%.c
	$(BUILD) $(DEMOFLAGS) -o$@ $< $(LDFLAGS)

$(TESTS): %: $(testdir)/%.c
	$(BUILD) $(DEMOFLAGS) -o$@ $< $(LDFLAGS)

tuidemo$(E) : tuidemo.o tui.o
	$(LINK) tui.o tuidemo.o -o $@ $(LDFLAGS)

tui.o: $(demodir)/tui.c $(demodir)/tui.h
	$(BUILD) -c $(DEMOFLAGS) $(demodir)/tui.c

tuidemo.o: $(demodir)/tuidemo.c
	$(BUILD) -c $(DEMOFLAGS) $(demodir)/tuidemo.c

include $(demodir)/nctests.mif

install:
	cp lib$(DLLNAME).so /usr/local/lib
	ldconfig /usr/local/lib

uninstall:
	$(RM) /usr/local/lib/lib$(DLLNAME).so
	ldconfig /usr/local/lib

=== os2gui/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "MinSizeRel" CACHE STRING "Choose the type of build, options are: Debug, Release, or MinSizeRel." FORCE)
    message(STATUS "No build type specified, defaulting to MinSizeRel.")
endif()

PROJECT(wingui VERSION "${PROJECT_VERSION}" LANGUAGES C)

INCLUDE(project_common)

demo_app(../demos calendar)
demo_app(../demos firework)
demo_app(../demos init_col)
demo_app(../demos mbrot)
demo_app(../demos newtest WIN32)
demo_app(../demos ozdemo)
demo_app(../demos picsview)
demo_app(../demos ptest)
demo_app(../demos rain)
demo_app(../demos speed)
demo_app(../demos test_pan)
demo_app(../demos testcurs)
demo_app(../demos version)
demo_app(../demos widetest)
demo_app(../demos worm)
demo_app(../demos xmas)


SET(CPACK_COMPONENTS_ALL applications)

=== os2gui/Makefile ===
# GNU MAKE Makefile for PDCurses library - OS/2 emx 0.9c+
#
# Usage: [g]make [-f path\Makefile] [DEBUG=Y] [DLL=Y] [target]
#
# where target can be any of:
# [all|libs|demos|pdcurses.a|pdcurses.dll|testcurs.exe...]
#

E = .exe

RM = del
CP = copy
# use following for running under 4OS/2
#RM = rm
#CP = cp

ifndef PDCURSES_SRCDIR
	PDCURSES_SRCDIR = ..
endif

osdir		= $(PDCURSES_SRCDIR)/os2gui
common		= $(PDCURSES_SRCDIR)/common

include $(common)/libobjs.mif

#PDCURSES_OS2_H	= $(osdir)/pdcos2.h

CC		= gcc

CFLAGS = -I$(PDCURSES_SRCDIR) -c -Wall

ifeq ($(DEBUG),Y)
	CFLAGS  += -g -DPDCDEBUG
	LDFLAGS = -g
else
	CFLAGS  += -O2
	LDFLAGS =
endif

DLLTARGET	= pdcurses.dll
DLLFLAGS 	= -Zdll -Zcrtdll -Zomf

LINK		= gcc
#EMXBIND		= emxbind
#EMXOMF		= emxomf

LIBEXE		= ar
LIBFLAGS	= rcv

ifeq ($(DLL),Y)
	O = obj
	CFLAGS += -Zdll -Zcrtdll -Zomf
	LDFLAGS += -Zomf -Zcrtdll
	LIBCURSES = pdcurses.lib
	LIBDEPS = $(LIBOBJS) $(PDCOBJS)
	PDCLIBS = $(DLLTARGET)
	EXEPOST =
	TUIPOST =
	CLEAN = *.dll *.lib
else
	O = o
#	CFLAGS += -Zomf
	LDFLAGS += -Zomf
	LIBCURSES = pdcurses.a
	LIBDEPS = $(LIBOBJS) $(PDCOBJS)
	PDCLIBS = $(LIBCURSES)
#	EXEPOST = $(EMXBIND) $* $(BINDFLAGS)
#	TUIPOST = $(EMXBIND) tuidemo $(BINDFLAGS)
	CLEAN = *.a
endif

.PHONY: all libs clean demos dist

all:	libs demos

libs:	$(PDCLIBS)

clean:
	-$(RM) *.$(O)
	-$(RM) *.def
	-$(RM) *.exe
	-$(RM) $(CLEAN)

demos:	$(DEMOS)

DEMOOBJS = calendar.$(O) firework.$(O) init_col.$(O) mbrot.$(O) newtest.$(O) \
 ozdemo.$(O) picsview.$(O) ptest.$(O) rain.$(O) speed.$(O) test_pan.$(O) testcurs.$(O) \
 tui.$(O) tuidemo.$(O) widetest.$(O) worm.$(O) xmas.$(O)

pdcurses.a : $(LIBDEPS)
	$(LIBEXE) $(LIBFLAGS) $@ $?
	-$(CP) $@ panel.a

pdcurses.lib : $(DLLTARGET)
	emximp -o $@ $*.def
	-$(CP) $@ panel.lib

$(DLLTARGET) : $(LIBDEPS)
	echo "LIBRARY PDCURSES INITINSTANCE" > $*.def
	echo "DATA MULTIPLE NONSHARED" >> $*.def
	echo "DESCRIPTION \"PDCURSES DLL for OS/2\"" >> $*.def
	echo "STACKSIZE 81920" >> $*.def
	echo "EXPORTS" >> $*.def
	emxexp $(LIBDEPS) >> $*.def
	$(LINK) $(DLLFLAGS) -o $@ $(LIBDEPS) $*.def
#	lxlite $@

$(LIBOBJS) $(PDCOBJS) $(DEMOOBJS) : $(PDCURSES_HEADERS)
$(PDCOBJS) : $(PDCURSES_OS2_H)
$(DEMOS) : $(LIBCURSES)
panel.$(O) ptest.$(O): $(PANEL_HEADER)
terminfo.$(O): $(TERM_HEADER)

$(LIBOBJS) : %.$(O): $(srcdir)/%.c
	$(CC) -c $(CFLAGS) -o$@ $<

$(PDCOBJS) : %.$(O): $(osdir)/%.c
	$(CC) -c $(CFLAGS) -o$@ $<

$(DEMOS_EXCEPT_TUIDEMO): %.exe: %.$(O)
	echo "NAME $* WINDOWAPI" > $*.def
	$(LINK) $(LDFLAGS) -o $*$(E) $< $(LIBCURSES) $(CCLIBS) $*.def
	$(EXEPOST)

tuidemo.exe:	tuidemo.$(O) tui.$(O)
	echo "NAME tuidemo WINDOWAPI" > tuidemo.def
	$(LINK) $(LDFLAGS) -o tuidemo tuidemo.$(O) tui.$(O) $(LIBCURSES) $(CCLIBS) tuidemo.def
	$(TUIPOST)

calendar.$(O) firework.$(O) init_col.$(O) mbrot.$(O) newtest.$(O) ozdemo.$(O) picsview.$(O) \
 ptest.$(O) rain.$(O) speed.$(O) test_pan.$(O) testcurs.$(O) widetest.$(O) worm.$(O) xmas.$(O): %.$(O): \
$(demodir)/%.c
	$(CC) $(CFLAGS) -o$@ $<

tui.$(O): $(demodir)\tui.c $(demodir)\tui.h
	$(CC) $(CFLAGS) -I$(demodir) -o $@ $<

tuidemo.$(O): $(demodir)\tuidemo.c
	$(CC) $(CFLAGS) -I$(demodir) -o $@ $<

=== sdl2/Makefile ===
# GNU MAKE Makefile for PDCurses for SDL2
#
# Usage: [g]make [DEBUG=Y] [WIDE=Y] [UTF8=Y] [LIBNAME=(name)]
#                [DLLNAME=(name)] [target]
#
# where target can be any of:
# [all|demos|libpdcurses.a|testcurs]...

O = o

ifndef PDCURSES_SRCDIR
	PDCURSES_SRCDIR	= ..
endif

osdir		= $(PDCURSES_SRCDIR)/sdl2
common		= $(PDCURSES_SRCDIR)/common

include $(common)/libobjs.mif

ifdef _w32
	PREFIX = i686-w64-mingw32
	E = .exe
endif

ifdef _w64
	PREFIX = x86_64-w64-mingw32
	E = .exe
endif

ifdef _a64
	PREFIX = aarch64-w64-mingw32
	E = .exe
endif

ifeq ($(OS),Windows_NT)
	E = .exe
	RM = cmd /c del

	include $(osdir)/versions.mif

	PLATFORM = $(shell $(CC) -dumpmachine)

	SFLAGS = -I$(SDLBASE)/$(PLATFORM)/include/SDL2
	SLIBS = -L$(SDLBASE)/$(PLATFORM)/lib -lSDL2main -lSDL2

	TFLAGS = -I$(TTFBASE)/$(PLATFORM)/include/SDL2
	TLIBS = -L$(TTFBASE)/$(PLATFORM)/lib -lSDL2_ttf

	DEMOFLAGS = -mwindows
else
	RM = rm -f

	SFLAGS = $(shell sdl2-config --cflags)
	SLIBS = $(shell sdl2-config --libs)

	TFLAGS = -I$(TTFBASE)/$(PREFIX)/include/SDL2
	TLIBS = -L$(TTFBASE)/$(PREFIX)/lib -lSDL2_ttf
endif

CC		= $(PREFIX)-gcc
WINDRES		= windres

PDCURSES_SDL_H	= $(osdir)/pdcsdl.h

CFLAGS  = -Wall -Wextra -Werror -pedantic -fPIC
ifeq ($(DEBUG),Y)
	CFLAGS  += -g -DPDCDEBUG
else
	CFLAGS  += -O2
endif

ifeq ($(WIDE),Y)
	CFLAGS += -DPDC_WIDE
	SFLAGS += $(TFLAGS)
	SLIBS  += $(TLIBS)
endif

ifeq ($(UTF8),Y)
	CFLAGS += -DPDC_FORCE_UTF8
	ifneq ($(WIDE),Y)
		SFLAGS += $(TFLAGS)
		SLIBS  += $(TLIBS)
	endif
endif

ifdef CHTYPE_32
	CFLAGS += -DCHTYPE_32
endif

LIBNAME=pdcurses
DLLNAME=pdcurses

ifeq ($(DLL),Y)
	ifeq ($(OS),Windows_NT)
		CFLAGS += -DPDC_DLL_BUILD
		LIBEXE = $(CC)
		LIBFLAGS = -Wl,--out-implib,lib$(LIBNAME).a -shared -o
		LIBCURSES = $(DLLNAME).dll
		CLEAN = $(LIBCURSES) *.a
		RESOURCE = pdcurses.o
		LIBLIBS = $(SLIBS)
		LDFLAGS = $(LIBCURSES)
	else
		ifeq ($(shell uname -s),Darwin)
			DLL_SUFFIX = .dylib
		else
			DLL_SUFFIX = .so
		endif
		LIBEXE = $(CC)
		LIBFLAGS = -shared -o
		LIBCURSES = lib$(DLLNAME)$(DLL_SUFFIX)
		LIBLIBS = $(SLIBS)
		LDFLAGS = $(LIBCURSES)
		CLEAN = *$(DLL_SUFFIX)
	endif
else
	LIBEXE = $(PREFIX)-$(AR)
	LIBFLAGS = rcv
	LIBCURSES = lib$(LIBNAME).a
	LDFLAGS = $(LIBCURSES) $(SLIBS)
	CLEAN = *.a
endif

BUILD		= $(CC) $(CFLAGS) -I$(PDCURSES_SRCDIR)

LINK		= $(CC)

DEMOS		+= sdltest$(E)

.PHONY: all libs clean demos tests

all:	libs

libs:	$(LIBCURSES)

clean:
	-$(RM) *.o trace $(CLEAN) $(DEMOS) $(TESTS)

demos:	$(DEMOS)
ifneq ($(DEBUG),Y)
	$(PREFIX)-strip $(DEMOS)
endif

tests:	$(TESTS)
ifneq ($(DEBUG),Y)
	$(PREFIX)-strip $(TESTS)
endif

install:
ifneq ($(OS),Windows_NT)
	cp lib$(DLLNAME).so /usr/local/lib
	ldconfig /usr/local/lib
endif

uninstall:
ifneq ($(OS),Windows_NT)
	$(RM) /usr/local/lib/lib$(DLLNAME).so
	ldconfig /usr/local/lib
endif

$(LIBCURSES) : $(LIBOBJS) $(PDCOBJS) $(RESOURCE)
	$(LIBEXE) $(LIBFLAGS) $@ $? $(LIBLIBS)

pdcurses.o: $(common)/pdcurses.rc
	$(WINDRES) -i $(common)/pdcurses.rc pdcurses.o

$(LIBOBJS) $(PDCOBJS) : $(PDCURSES_HEADERS)
$(PDCOBJS) : $(PDCURSES_SDL_H)
$(DEMOS) : $(PDCURSES_CURSES_H) $(LIBCURSES)
$(TESTS) : $(PDCURSES_CURSES_H) $(LIBCURSES)
tui.o tuidemo.o : $(PDCURSES_CURSES_H)
terminfo.o : $(TERM_HEADER)
panel.o ptest$(E) test_pan$(E): $(PANEL_HEADER)

$(LIBOBJS) : %.o: $(srcdir)/%.c
	$(BUILD) -c $<

$(PDCOBJS) : %.o: $(osdir)/%.c
	$(BUILD) $(SFLAGS) -c $<

$(TESTS): %: $(testdir)/%.c
	$(BUILD) $(DEMOFLAGS) -o$@ $< $(LDFLAGS)

$(DEMOS_EXCEPT_TUIDEMO): %: $(demodir)/%.c
	$(BUILD) $(DEMOFLAGS) -o$@ $< $(LDFLAGS)

tuidemo$(E): tuidemo.o tui.o
	$(LINK) tui.o tuidemo.o -o $@ $(LDFLAGS)

sdltest$(E): $(osdir)/sdltest.c
	$(BUILD) $(SFLAGS) $(DEMOFLAGS) -o $@ $< $(LIBCURSES) $(SLIBS)

tui.o: $(demodir)/tui.c $(demodir)/tui.h
	$(BUILD) -c $(DEMOFLAGS) $(demodir)/tui.c

tuidemo.o: $(demodir)/tuidemo.c
	$(BUILD) -c $(DEMOFLAGS) $(demodir)/tuidemo.c

include $(demodir)/nctests.mif

=== wingui/Makefile ===
# GNU MAKE Makefile for PDCurses library - WIN32/64/ARM MinGW GCC/LLVM
#
# Usage: [g]make [-f path\Makefile] [DEBUG=Y] [DLL=Y] [WIDE=Y] [UTF8=Y]
#        [LIBNAME=(name)] [DLLNAME=(name)] [target]
#        [_w32=Y | _w64=Y | _a64=Y ]
#
# where target can be any of:
# [all|demos|pdcurses.a|testcurs.exe...]

O = o
E = .exe

ifndef PDCURSES_SRCDIR
	PDCURSES_SRCDIR = ..
endif

osdir		= $(PDCURSES_SRCDIR)/wingui
common		= $(PDCURSES_SRCDIR)/common

include $(common)/libobjs.mif

uname_S := $(shell uname -s 2>/dev/null)

CAT		= cat
PREFIX		=
PATH_SEP		= /
CP		= cp
RM		= rm -f

# It appears we have three cases:  we're running in Cygwin/MSYS;  or we're
# running in command.com on Windows with MinGW;  or we're on Linux or BSD
# or similar system,  cross-compiling with MinGW.

ifneq (,$(findstring CYGWIN,$(uname_S)))
	#  Insert Cygwin-specific changes here
	ON_WINDOWS = 1
endif
ifneq (,$(findstring MINGW32_NT,$(uname_S)))
	#  Insert MINGW32-specific changes here
	ON_WINDOWS = 1
endif
ifneq (,$(findstring MINGW64_NT,$(uname_S)))
	#  Insert MINGW64-specific changes here
	ON_WINDOWS = 1
endif

ifeq ($(uname_S),)
	CAT = type
	PATH_SEP = \\
	CP = copy
	RM = cmd /c del
	ON_WINDOWS = 1
endif

# If we aren't on Windows,  assume MinGW on a Linux-like host
# Only decision is:  are we doing a 64-bit compile (_w64 defined)?

ifndef ON_WINDOWS
	PREFIX  = i686-w64-mingw32-
	ifdef _w64
		PREFIX  = x86_64-w64-mingw32-
	endif
	ifdef _a64
		PREFIX  = aarch64-w64-mingw32-
	endif
endif

PDCURSES_WIN_H	= $(osdir)/pdcwin.h

CC	= $(PREFIX)gcc

AR	= $(PREFIX)ar
STRIP	= $(PREFIX)strip

CFLAGS  += -Wall -Wextra -pedantic
ifeq ($(DEBUG),Y)
	CFLAGS  += -g -DPDCDEBUG
	LDFLAGS = -g
else
	CFLAGS  += -O3
	LDFLAGS =
endif

CFLAGS += -I$(PDCURSES_SRCDIR)

ifdef CHTYPE_32
	CFLAGS += -DCHTYPE_32
endif

ifeq ($(UTF8),Y)
	CFLAGS	+= -DPDC_FORCE_UTF8
else
	ifeq ($(WIDE),Y)
		CFLAGS	+= -DPDC_WIDE
	endif
endif

LINK	   = $(CC)
LIBNAME = pdcurses
DLLNAME = pdcurses

ifeq ($(DLL),Y)
	CFLAGS += -DPDC_DLL_BUILD
	LIBEXE = $(CC)
	LIBFLAGS = -Wl,--out-implib,$(LIBNAME).a -static-libgcc -shared -o
	LIBCURSES = $(DLLNAME).dll
	LIBDEPS = $(LIBOBJS) $(PDCOBJS)
	LIBSADDED = -lgdi32 -lcomdlg32 -lwinmm
	EXELIBS =
	CLEAN = $(LIBCURSES) *.a
else
	LIBEXE = $(AR)
ifeq ($(PREFIX),)
	LIBFLAGS = rcv
else
	LIBFLAGS = rv
endif
	LIBCURSES = $(LIBNAME).a
	LIBDEPS = $(LIBOBJS) $(PDCOBJS)
	LIBSADDED =
	EXELIBS = -lgdi32 -lcomdlg32 -lwinmm
	CLEAN = *.a
endif

.PHONY: all libs clean demos dist tests

all:	libs

libs:	$(LIBCURSES)

clean:
	-$(RM) *.o
	-$(RM) *.exe
	-$(RM) *.dll
	-$(RM) $(CLEAN)

demos:	$(DEMOS)
ifneq ($(DEBUG),Y)
	$(STRIP) *.exe
endif

tests:	libs $(TESTS)
ifneq ($(DEBUG),Y)
	$(STRIP) $(TESTS)
endif

$(LIBCURSES) : $(LIBDEPS)
	$(LIBEXE) $(LIBFLAGS) $@ $? $(LIBSADDED)
	$(CP) $(LIBNAME).a panel.a

$(LIBOBJS) $(PDCOBJS) : $(PDCURSES_HEADERS)
$(PDCOBJS) : $(PDCURSES_WIN_H)
$(DEMOS) : $(PDCURSES_CURSES_H) $(LIBCURSES)
panel.o : $(PANEL_HEADER)

$(LIBOBJS) : %.o: $(srcdir)/%.c
	$(CC) -c $(CFLAGS) $<

$(PDCOBJS) : %.o: $(osdir)/%.c
	$(CC) -c $(CFLAGS) $<

$(DEMOS_EXCEPT_TUIDEMO): %.exe: $(demodir)/%.c
	$(CC) $(CFLAGS) -mwindows -o$@ $< $(LIBCURSES) $(EXELIBS)

$(TESTS): %.exe: $(testdir)/%.c
	$(CC) $(CFLAGS) -mwindows -o$@ $< $(LIBCURSES) $(EXELIBS)

tuidemo.exe: tuidemo.o tui.o
	$(LINK) $(LDFLAGS) -mwindows -o$@ tuidemo.o tui.o $(LIBCURSES) $(EXELIBS)

tui.o: $(demodir)/tui.c $(demodir)/tui.h $(PDCURSES_CURSES_H)
	$(CC) -c $(CFLAGS) -I$(demodir) -o$@ $<

tuidemo.o: $(demodir)/tuidemo.c $(PDCURSES_CURSES_H)
	$(CC) -c $(CFLAGS) -I$(demodir) -o$@ $<

configure :
	$(CC) $(CFLAGS) -o config_curses$(E) $(common)/config_curses.c
ifdef ON_WINDOWS
	config_curses$(E) -v -d.. $(CFLAGS)
else
	wine config_curses$(E) -v -d.. $(CFLAGS)
endif
	rm config_curses$(E)

include $(PDCURSES_SRCDIR)/demos/nctests.mif

=== x11new/Makefile ===
# GNU MAKE Makefile for PDCurses library for new X11
#
# Usage: [g]make [DEBUG=Y] [WIDE=Y] [UTF8=Y] [LIBNAME=(name)]
#                [DLLNAME=(name)] [target]
#
# where target can be any of:
# [all|demos|libpdcurses.a|testcurs]...

O = o

ifndef PDCURSES_SRCDIR
	PDCURSES_SRCDIR = ..
endif

osdir		= $(PDCURSES_SRCDIR)/x11new
common		= $(PDCURSES_SRCDIR)/common

include $(common)/libobjs.mif

RM		= rm -f

# If your system doesn't have these, remove the defines here
SFLAGS		= -DHAVE_VSNPRINTF -DHAVE_VSSCANF

CFLAGS  = -Wall -Wextra -pedantic -Werror
ifeq ($(DEBUG),Y)
	CFLAGS  += -g -DPDCDEBUG
else
	CFLAGS  += -O2
endif

ifeq ($(NO_LEAKS),Y)
	CFLAGS  += -DNO_LEAKS
endif

CFLAGS	+= -fPIC

ifeq ($(UTF8),Y)
	CFLAGS	+= -DPDC_FORCE_UTF8
else
	ifeq ($(WIDE),Y)
		CFLAGS	+= -DPDC_WIDE
	endif
endif

ifdef CHTYPE_32
	CFLAGS += -DCHTYPE_32
endif

LIBNAME=libpdcurses
DLLNAME=pdcurses
XLIBS = -lX11 -lpthread

LIBFLAGS = rv
LIBCURSES	= $(LIBNAME).a
CC	= $(PREFIX)gcc
LIBEXE = $(PREFIX)ar
STRIP	= $(PREFIX)strip

ifeq ($(shell uname -s),FreeBSD)
	CC = cc
	CFLAGS += -I/usr/local/include
	LDFLAGS += -L /usr/local/lib
endif

ifeq ($(DLL),Y)
	ifeq ($(shell uname -s),Darwin)
		DLL_SUFFIX = .dylib
	else
		DLL_SUFFIX = .so
	endif
	LIBEXE = $(CC)
	LIBFLAGS = -shared -o
	LIBCURSES = lib$(DLLNAME)$(DLL_SUFFIX)
endif

BUILD		= $(CC) $(CFLAGS) -I$(PDCURSES_SRCDIR)

LINK		= $(CC)
LDFLAGS		= $(LIBCURSES) $(XLIBS)
RANLIB		= $(PREFIX)ranlib

.PHONY: all libs clean demos tests

all:	libs

libs:	$(LIBCURSES)

clean:
	-$(RM) *.o trace $(LIBCURSES) $(DEMOS) $(TESTS)

demos:	libs $(DEMOS)
ifneq ($(DEBUG),Y)
	$(STRIP) $(DEMOS)
endif

tests:	libs $(TESTS)
ifneq ($(DEBUG),Y)
	$(STRIP) $(TESTS)
endif

$(LIBCURSES) : $(LIBOBJS) $(PDCOBJS)
	$(LIBEXE) $(LIBFLAGS) $@ $?
ifeq ($(LIBCURSES),$(LIBNAME).a)
	-$(RANLIB) $@
endif

$(LIBOBJS) $(PDCOBJS) : $(PDCURSES_HEADERS)
$(DEMOS) : $(PDCURSES_CURSES_H) $(LIBCURSES)
$(TESTS) : $(PDCURSES_CURSES_H) $(LIBCURSES)
tui.o tuidemo.o : $(PDCURSES_CURSES_H)
terminfo.o : $(TERM_HEADER)
panel.o ptest: $(PANEL_HEADER)

$(LIBOBJS) : %.o: $(srcdir)/%.c
	$(BUILD) $(SFLAGS) -c $<

$(PDCOBJS) : %.o: $(osdir)/%.c
	$(BUILD) $(SFLAGS) -c $<

$(DEMOS_EXCEPT_TUIDEMO): %: $(demodir)/%.c
	$(BUILD) $(DEMOFLAGS) -o$@ $< $(LDFLAGS)

$(TESTS): %: $(testdir)/%.c
	$(BUILD) $(DEMOFLAGS) -o$@ $< $(LDFLAGS)

tuidemo$(E) : tuidemo.o tui.o
	$(LINK) tui.o tuidemo.o -o $@ $(LDFLAGS)

tui.o: $(demodir)/tui.c $(demodir)/tui.h
	$(BUILD) -c $(DEMOFLAGS) $(demodir)/tui.c

tuidemo.o: $(demodir)/tuidemo.c
	$(BUILD) -c $(DEMOFLAGS) $(demodir)/tuidemo.c

configure :
	$(CC) $(CFLAGS) -o config_curses $(common)/config_curses.c
	./config_curses -v -d.. $(CFLAGS)
	rm config_curses

include $(demodir)/nctests.mif

install:
	cp lib$(DLLNAME).so /usr/local/lib
	ldconfig /usr/local/lib

uninstall:
	$(RM) /usr/local/lib/lib$(DLLNAME).so
	ldconfig /usr/local/lib

=== cmake/sdl2_ttf/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 3.11)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "MinSizeRel" CACHE STRING "Choose the type of build, options are: Debug, Release, or MinSizeRel." FORCE)
    message(STATUS "CMAKE_BUILD_TYPE not set, defaulting to MinSizeRel.")
endif()

PROJECT (sdl2_ttf VERSION ${SDL2_TTF_RELEASE} LANGUAGES C)

if(MSVC)
    SET(CMAKE_DEBUG_POSTFIX d)
endif()    

INCLUDE_DIRECTORIES(
    ${ZLIB_INCLUDE_DIR}
    ${FT2_INCLUDE_DIR}
    ${SDL2_INCLUDE_DIR})

LINK_DIRECTORIES(
    ${ZLIB_LIBRARY_DIR}
    ${FT2_LIBRARY_DIR}
    ${SDL2_LIBRARY_DIR})


INSTALL (FILES SDL_ttf.h DESTINATION ${CMAKE_INSTALL_PREFIX}/include/SDL2_ttf)

set(SDL2_ttf_source_files SDL_ttf.c)

IF(WIN32)
    LIST(INSERT SDL2_ttf_source_files 0 version.rc)
ENDIF()    

if (APPLE)
    find_library(COREVIDEO CoreVideo)
    list(APPEND EXTRA_LIBS ${COREVIDEO})

    find_library(COCOA_LIBRARY Cocoa)
    list(APPEND EXTRA_LIBS ${COCOA_LIBRARY})

    find_library(IOKIT IOKit)
    list(APPEND EXTRA_LIBS ${IOKIT})

    find_library(FORCEFEEDBACK ForceFeedback)
    list(APPEND EXTRA_LIBS ${FORCEFEEDBACK})

    find_library(CARBON_LIBRARY Carbon)
    list(APPEND EXTRA_LIBS ${CARBON_LIBRARY})

    find_library(COREAUDIO CoreAudio)
    list(APPEND EXTRA_LIBS ${COREAUDIO})

    find_library(AUDIOTOOLBOX AudioToolbox)
    list(APPEND EXTRA_LIBS ${AUDIOTOOLBOX})

    include(CheckLibraryExists)
    check_library_exists(iconv iconv_open "" HAVE_LIBICONV)
    if(HAVE_LIBICONV)
      list(APPEND EXTRA_LIBS iconv)
    endif()
endif()

ADD_LIBRARY(SDL2_ttf-static STATIC ${SDL2_ttf_source_files} SDL_ttf.h)
SET_TARGET_PROPERTIES (SDL2_ttf-static PROPERTIES
    DEFINE_SYMBOL DLL_EXPORT
    PUBLIC_HEADER SDL_ttf.h
    EXPORT_NAME SDL2_ttf-static
    C_VISIBILITY_PRESET "hidden"
)
INSTALL (TARGETS SDL2_ttf-static 
    ARCHIVE DESTINATION ${CMAKE_INSTALL_PREFIX}/lib
    COMPONENT libraries)

ADD_LIBRARY(SDL2_ttf SHARED ${SDL2_ttf_source_files} SDL_ttf.h)
TARGET_LINK_LIBRARIES (SDL2_ttf  ${SDL2_LIBRARY} ${FT2_LIBRARY} ${ZLIB_LIBRARY} ${EXTRA_LIBS})
SET_TARGET_PROPERTIES (SDL2_ttf PROPERTIES
    DEFINE_SYMBOL DLL_EXPORT
    PUBLIC_HEADER SDL_ttf.h
    EXPORT_NAME SDL2_ttf
    C_VISIBILITY_PRESET "hidden"
)
INSTALL (TARGETS SDL2_ttf
    ARCHIVE DESTINATION ${CMAKE_INSTALL_PREFIX}/lib
    RUNTIME DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/lib
    COMPONENT libraries)

ADD_EXECUTABLE (showfont ${CMAKE_SOURCE_DIR}/showfont.c)
TARGET_LINK_LIBRARIES (showfont SDL2_ttf  ${SDL2_LIBRARIES} ${FT2_LIBRARY} ${ZLIB_LIBRARY} ${EXTRA_LIBS})
INSTALL (TARGETS showfont RUNTIME DESTINATION ${CMAKE_INSTALL_PREFIX}/bin COMPONENT applications)

ADD_EXECUTABLE (glfont ${CMAKE_SOURCE_DIR}/glfont.c)
TARGET_LINK_LIBRARIES (glfont SDL2_ttf ${SDL2_LIBRARIES} ${FT2_LIBRARY} ${ZLIB_LIBRARY} ${EXTRA_LIBS})
INSTALL (TARGETS glfont RUNTIME DESTINATION ${CMAKE_INSTALL_PREFIX}/bin COMPONENT applications)

set(CPACK_COMPONENTS_ALL libraries applications)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Contributor: Simon Sobisch <simonsobisch@gnu.org>

_realname=pdcurses
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
provides=("${MINGW_PACKAGE_PREFIX}-curses")
# No replace or conflict as the installed names are different
#replaces=("${MINGW_PACKAGE_PREFIX}-ncurses" "${MINGW_PACKAGE_PREFIX}-termcap")
#conflicts=("${MINGW_PACKAGE_PREFIX}-ncurses" "${MINGW_PACKAGE_PREFIX}-termcap")
pkgver=4.5.3
pkgrel=1
pkgdesc="Curses library on the Win32 API (mingw-w64)"
# ports that are available with this package
_pdcports="wincon wingui vt"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.projectpluto.com/win32a.htm"
msys2_repository_url="https://github.com/Bill-Gray/PDCursesMod"
license=('Public Domain')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
changelog=${_realname}.changelog
source=("https://github.com/Bill-Gray/PDCursesMod/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('5be1c4a1ba42c958deb219e6fe45fd3315444bc47cfe0c89f5ac0d8c00cc5930')

#prepare() {
#  cd PDCursesMod-${pkgver}
#  patch -p1 -i "${srcdir}"/001-mingw-pdcurses-4.3.x-build.patch
#}

build() {
  cd "${srcdir}/PDCursesMod-${pkgver}"

  for pdc_port in ${_pdcports}; do
    cp -rf ${pdc_port} ${pdc_port}-shared-${MSYSTEM}
    make -C ${pdc_port}-shared-${MSYSTEM} \
        CC=${MINGW_PREFIX}/bin/cc \
        STRIP=${MINGW_PREFIX}/bin/strip \
        AR=${MINGW_PREFIX}/bin/ar \
        LIBNAME=libpdcurses.dll \
        DLLNAME=libpdcurses \
        WIDE=Y \
        UTF8=Y \
        DLL=Y

    cp -rf ${pdc_port} ${pdc_port}-static-${MSYSTEM}
    make -C ${pdc_port}-static-${MSYSTEM} \
        CC=${MINGW_PREFIX}/bin/cc \
        STRIP=${MINGW_PREFIX}/bin/strip \
        AR=${MINGW_PREFIX}/bin/ar \
        LIBNAME=libpdcurses \
        WIDE=Y \
        UTF8=Y
  done
}

# we use the check target to verify that the demos would link correctly
# and could then (manually) run the tests to verify the results *look* correct
check() {
  cd "${srcdir}/PDCursesMod-${pkgver}"

  for pdc_port in ${_pdcports}; do
    cp -rf ${pdc_port} ${pdc_port}-shared-${MSYSTEM}
    make -C ${pdc_port}-shared-${MSYSTEM} \
        CC=${MINGW_PREFIX}/bin/cc \
        STRIP=${MINGW_PREFIX}/bin/strip \
        AR=${MINGW_PREFIX}/bin/ar \
        LIBNAME=libpdcurses.dll \
        DLLNAME=libpdcurses \
        WIDE=Y \
        UTF8=Y \
        DLL=Y \
        demos

    cp -rf ${pdc_port} ${pdc_port}-static-${MSYSTEM}
    make -C ${pdc_port}-static-${MSYSTEM} \
        CC=${MINGW_PREFIX}/bin/cc \
        STRIP=${MINGW_PREFIX}/bin/strip \
        AR=${MINGW_PREFIX}/bin/ar \
        LIBNAME=libpdcurses \
        WIDE=Y \
        UTF8=Y \
        demos
  done
}

package() {
  cd "${srcdir}/PDCursesMod-${pkgver}"

  mkdir -p "${pkgdir}"${MINGW_PREFIX}/{bin,include,lib}
  mkdir "${pkgdir}"${MINGW_PREFIX}/include/pdcurses

  # no exe - those are only demos and only run for check
  #install "wingui-shared-${MSYSTEM}/*.exe "${pkgdir}"${MINGW_PREFIX}/bin/

  # install dll and shared library of the "default port" (as in earlier versions of this package: wingui)
  install "wingui-shared-${MSYSTEM}/libpdcurses.dll" "${pkgdir}${MINGW_PREFIX}/bin/"
  install "wingui-static-${MSYSTEM}/libpdcurses.a"   "${pkgdir}${MINGW_PREFIX}/lib/"

  # as all share the same ABI and the binaries are intended to work only with the basename - only install one link library
  install "wingui-shared-${MSYSTEM}/libpdcurses.dll.a" "${pkgdir}${MINGW_PREFIX}/lib/"

  # the additional static libraries and actual dll's go in with a rename
  for pdc_port in ${_pdcports}; do
    install "${pdc_port}-static-${MSYSTEM}/libpdcurses.a"   "${pkgdir}${MINGW_PREFIX}/lib/libpdcurses_${pdc_port}.a"
    install "${pdc_port}-shared-${MSYSTEM}/libpdcurses.dll" "${pkgdir}${MINGW_PREFIX}/bin/libpdcurses_${pdc_port}.dll"
  done

  install -m 0644 curses.h panel.h term.h "${pkgdir}"${MINGW_PREFIX}/include/pdcurses/
  # needs defines matching the make step, see https://github.com/Bill-Gray/PDCursesMod/issues/133
  echo '/* if you want to use the DLL one: #define PDC_DLL_BUILD 1 */' > pdcurses.h
  echo '/* if you want to use ncurses compatible mouse: #define PDC_NCMOUSE 1 */' >> pdcurses.h
  echo '#define PDC_WIDE 1'           >> pdcurses.h
  echo '#define PDC_FORCE_UTF8 1'     >> pdcurses.h
  echo '#include "pdcurses/curses.h"' >> pdcurses.h
  install -m 0644 pdcurses.h "${pkgdir}"${MINGW_PREFIX}/include/pdcurses.h
}
